<?php
/***************************************************************************
 *
 * 	----------------------------------------------------------------------
 * 						DO NOT EDIT THIS FILE
 *	----------------------------------------------------------------------
 * 
 *  				     Copyright (C) Themify
 * 
 *	----------------------------------------------------------------------
 *
 ***************************************************************************/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/* 	Database Functions
/***************************************************************************/
	
	/**
	 * Save Data
	 * @param Array $data
	 * @return String
	 * @since 1.0.0
	 * @package themify
	 */
	function themify_set_data( $data ){
		$theme = wp_get_theme();
		foreach( $data as $name => $value ) {
			if( 'save' == $name || 'page' == $name ) {
				unset( $data[$name] );	
			}
		}

		$option_value = $data;
		update_option( $theme->display('Name') . '_themify_data', $option_value);
		return $option_value;
	}
		
	/**
	 * Get Data
	 * @return String
	 * @since 1.0.0
	 * @package themify
	 */
	function themify_get_data(){
		$theme = wp_get_theme();
		$data = get_option( $theme->display('Name') . '_themify_data' );
		if( is_array( $data ) && count( $data ) >= 1 ) {
			foreach( $data as $name => $value ){
				if ( 'setting-custom_css' == $name ) {
					$data[$name] = str_replace( "\'", "'", $value );
				} else {
					$data[$name] = stripslashes( $value );
				}
			}
		} else {
			$data = array();
		}
		return $data;
	}

	/**
	 * Get The Old Data
	 * @return String
	 * @since 1.0.0
	 * @package themify
	 */
	function themify_get_old_data(){
		$theme = wp_get_theme();
		$data = unserialize(base64_decode( get_option( $theme->display('Name') . '_themify_data' ) ));
		if(is_array($data) && count($data) >= 1){
			foreach($data as $name => $value){
				if ( 'setting-custom_css' == $name ) {
					$data[$name] = str_replace( "\'", "'", $value );
				} else {
					$data[$name] = stripslashes($value);
				}
			}
		}
		return $data;
	}
	
?>