<?php
/***************************************************************************
 *
 * 	----------------------------------------------------------------------
 * 						DO NOT EDIT THIS FILE
 *	----------------------------------------------------------------------
 * 
 *  				     Copyright (C) Themify
 * 
 *	----------------------------------------------------------------------
 *
 ***************************************************************************/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/* 	Setting Modules
/***************************************************************************/
	
	///////////////////////////////////////////
	// Site Logo
	///////////////////////////////////////////
	function themify_site_logo( $data = array() ) {
		if($data['attr']['target'] != ''){
			$target = "<span class='hide target'>".$data['attr']['target']."</span>";	
		}
		$data = themify_get_data();
		$text = '';
		$image = '';
		if( isset( $data['setting-site_logo'] ) && 'image' == $data['setting-site_logo'] ) {
			$image = "checked='checked'";
			$image_display = "style='display:block;'";
			$text_display = "style='display:none;'";
		} else {
			$text = "checked='checked'";	
			$text_display = "style='display:block;'";
			$image_display = "style='display:none;'";
		}
		$logo_image_value = themify_get( 'setting-site_logo_image_value' );
		$logo_image_width = themify_get( 'setting-site_logo_width' );
		$logo_image_height = themify_get( 'setting-site_logo_height' );
		return '<div class="themify_field_row">
					<span class="label">'. __('Display', 'themify') .'</span> 
						<input name="setting-site_logo" type="radio" value="text" '.$text.' /> ' . __('Site Title', 'themify') . ' 
						<input name="setting-site_logo" type="radio" value="image" '.$image.' /> ' . __('Image', 'themify') . '
					</span>
					'.$target.'
					<div class="uploader-fields image" '.$image_display.'>
						<input type="text" id="setting-site_logo" class="width10" name="setting-site_logo_image_value" value="'.$logo_image_value.'" />
						<div class="clear image" '.$image_display.'>' . themify_get_uploader('setting-site_logo', array('tomedia' => true)) . '</div>
					</div>
					<span class="pushlabel clear image" '.$image_display.'>
						<input type="text" name="setting-site_logo_width" class="width2" value="'.$logo_image_width.'" /> ' . __('width', 'themify') . '
						<input type="text" name="setting-site_logo_height" class="width2" value="'.$logo_image_height.'" /> ' . __('height', 'themify') . '
					</span>
				</div>';
	}
	
	///////////////////////////////////////////
	// Favicon Module
	///////////////////////////////////////////
	function themify_favicon( $data = array() ) {
		if($data['attr']['target'] != ''){
			$target = "<span class='hide target'>".$data['attr']['target']."</span>";	
		}
		$setting_favicon = themify_get( 'setting-favicon' );
		return '<div class="themify_field_row">
					<span class="label">'. __('Custom Favicon', 'themify') . '</span>
					<input id="setting-favicon" type="text" class="width10" name="setting-favicon" value="'.$setting_favicon.'" /> <br />
					'.$target.'
					<span class="pushlabel" style="display:block;">
						' . themify_get_uploader('setting-favicon', array('tomedia' => true)) . '
					</span>
				</div>';
	}

	///////////////////////////////////////////
	// Favicon Module - Action
	///////////////////////////////////////////
	function themify_favicon_action( $data = array() ) {
		$data = themify_get_data();
		if ( isset( $data['setting-favicon'] ) && $data['setting-favicon'] != '' ) {
			$favurl = themify_https_esc($data['setting-favicon']);
			echo "\n\n".'<link href="'.$favurl.'" rel="shortcut icon" /> ';
		}
	}
	add_action('wp_head', 'themify_favicon_action');
	add_action('admin_head', 'themify_favicon_action');
	
	///////////////////////////////////////////
	// Custom Feed URL Module
	///////////////////////////////////////////
	function themify_custom_feed_url( $data = array() ) {
		$custom_feed_url = themify_get( 'setting-custom_feed_url' );
		return '<p><span class="label">' . __('Custom Feed URL', 'themify') . '</span> <input type="text" class="width10" name="setting-custom_feed_url" value="'.$custom_feed_url.'" /> <br />
					<span class="pushlabel"><small>e.g. http://feedburner.com/userid</small></span></p>';
	}
	
	///////////////////////////////////////////
	// Custom Feed URL Module - Action
	///////////////////////////////////////////
	function themify_custom_feed_url_action( $data = array() ) {
		$data = themify_get_data();
		if( isset( $data['setting-custom_feed_url'] ) && $data['setting-custom_feed_url'] != '' ) {
			echo "\n\n".'<meta name="description" content="'.$data['setting-custom_feed_url'].'" /> ';
		}
	}
	add_action('wp-admin','themify_custom_feed_url_action');
	
	///////////////////////////////////////////
	// Meta Description Module
	///////////////////////////////////////////
	function themify_meta_description( $data = array() ) {
		$data = themify_get_data();
		return '<p><textarea type="text" name="setting-meta_description" class="widthfull" rows="4">'.$data['setting-meta_description'].'</textarea></p>';	
	}

	/**
	 * Meta Description Module - Action
	 * @param array $data
	 */
	function themify_meta_description_action( $data = array() ) {
		if( $meta_description = themify_get( 'setting-meta_description' ) ) {
			echo "\n\n" . '<meta name="description" content="' . $meta_description . '" /> ';
		}
	}
	add_action('wp-admin','themify_meta_description_action');

	/**
	 * Header HTML Module
	 * @param array $data
	 * @return string
	 */
	function themify_header_html( $data = array() ) {
		$header_html = themify_get( 'setting-header_html' );
		return '<p>' . __('The following code will add to the &lt;head&gt; tag.', 'themify') . '</p>
					<p><textarea class="widthfull" rows="10" name="setting-header_html">'.$header_html.'</textarea><br />
					<small>' . __('Useful if you need to add additional scripts such as CSS or JS.', 'themify') . '</small></p>';	
	}

	/**
	 * Header HTML Module - Action
	 * @param array $data
	 */
	function themify_header_html_action( $data = array() ) {
		echo "\n\n" . themify_get( 'setting-header_html' );
	}
	add_action('wp_head','themify_header_html_action');

	/**
	 * Footer HTML Module
	 * @param array $data
	 * @return string
	 */
	function themify_footer_html( $data = array() ) {
		$footer_html = themify_get( 'setting-footer_html' );
		return '<p>' . __('The following code will be added to the footer before the closing &lt;/body&gt; tag.', 'themify') . '</p>
					<p><textarea type="text" class="widthfull" rows="10" name="setting-footer_html">'.$footer_html.'</textarea><br />
					<small>' . __('Useful if you need to Javascript or tracking code.', 'themify') . '</small></p>';
	}

	/**
	 * Footer HTML Module - Action
	 * @param array $data
	 */
	function themify_footer_html_action( $data = array() ) {
		echo "\n\n" . themify_get( 'setting-footer_html' );
	}
	add_action('wp_footer','themify_footer_html_action');

	/**
	 * Custom CSS Module
	 * @param array $data
	 * @return string
	 */
	function themify_custom_css( $data = array() ) {
		$custom_css = themify_get( 'setting-custom_css' );
		return '<p><textarea class="widthfull" rows="35" name="setting-custom_css">'.$custom_css.'</textarea><br /></p>';
	}

	/**
	 * Custom CSS Module - Action
	 * @param array $data
	 */
	function themify_custom_css_action( $data = array() ) {
		if( $custom_css = themify_get( 'setting-custom_css' ) )
			echo "\n\n<!-- custom css -->\n\n<style type='text/css'>$custom_css</style>";
	}
	add_action('wp_head','themify_custom_css_action');
	
	///////////////////////////////////////////
	// Search Settings Module
	///////////////////////////////////////////
	function themify_search_settings( $data = array() ) {
		$data = themify_get_data();
		$checked = '';
		$search_settings = themify_get( 'setting-search_settings' );
		if ( isset( $data['setting-search_settings_exclude'] ) && $data['setting-search_settings_exclude'] ) {
			$checked = 'checked="checked"';	
		}
		$out = '<p>
					<span class="label">' . __('Search in Category IDs', 'themify') . ' </span>
					<input type="text" class="width6" name="setting-search_settings" value="'.$search_settings.'" />
				</p>
				<p>
					<span class="pushlabel"><small>' . __('Use minus sign (-) to exclude categories.', 'themify') . '</small></span><br />
					<span class="pushlabel"><small>' . __('Example: (1,4,-7) = search only in Category 1 &amp; 4, and exclude Category 7.', 'themify') . '</small></span>
				</p>
				<p>
					<span class="pushlabel"><label for="setting-search_settings_exclude"><input type="checkbox" id="setting-search_settings_exclude" name="setting-search_settings_exclude" '.$checked.'/> ' . __('Exclude Pages in search results', 'themify') . '</label></span>
				</p>';


		$pre = 'setting-search_exclude_';
		$checkboxes = '';

		$exclude_types = apply_filters( 'themify_types_excluded_in_search', get_post_types( array(
			'_builtin' => false,
			'public' => true,
			'exclude_from_search' => false
		)));
		
		foreach( array_keys( $exclude_types ) as $post_type ) :

			$type = get_post_type_object( $post_type );

			$checkboxes .= '
			<p>
				<span class="pushlabel">
					<label for="' . $pre . $type->name . '">
						<input type="checkbox" id="' . $pre . $type->name . '" name="' . $pre . $type->name . '" ' . checked( isset( $data[$pre . $type->name] ) ? $data[$pre . $type->name] : '', 'on', false ) . '/> ' . sprintf( __( 'Exclude %s in search results', 'themify' ), $type->labels->name ) . '
					</label>
				</span>
			</p>';

		endforeach;

		if ( '' != $checkboxes ) {
			$out .= $checkboxes;
		}

		return $out;
	}

////////////////////////////////////////////////////
// Exclude Custom Post Types from Search - Filter
////////////////////////////////////////////////////
if ( ! function_exists( 'themify_search_excludes_cpt' ) ) {
	function themify_search_excludes_cpt( $query ) {
		if ( ! is_admin() && $query->is_main_query() && $query->is_search ) {

			/////////////////////////////////
			// Set category search settings
			/////////////////////////////////
			$cat_search = themify_get( 'setting-search_settings' );
			if ( isset( $cat_search ) && $cat_search != '' ) {
				$query->set( 'cat', $cat_search );
			}

			//////////////////////////////////
			// Exclude pages & post types ////
			//////////////////////////////////
			$types = get_post_types();

			// Exclude pages /////////////////
			$exclude_pages = themify_get( 'setting-search_settings_exclude' );
			if ( isset( $exclude_pages ) && $exclude_pages ) {
				unset( $types['page'] );
			}

			// Exclude custom post types /////
			$exclude_types = apply_filters( 'themify_types_excluded_in_search', get_post_types( array(
				'_builtin' => false,
				'public' => true,
				'exclude_from_search' => false
			)));

			foreach( array_keys( $exclude_types ) as $type ) {
				$exclude_type = null;
				$exclude_type = themify_get( 'setting-search_exclude_' . $type );
				if ( isset( $exclude_type ) && $exclude_type ) {
					unset( $types[$type] );
				}
			}

			// Set final query parameters ////
			if ( $query->query_vars['post_type'] != 'product' ) {
				$query->set('post_type', $types);
			}

		}
		return $query;
	}
}
add_filter( 'pre_get_posts', 'themify_search_excludes_cpt', 12 );
	
	///////////////////////////////////////////
	// RSS Feed Settings Module
	///////////////////////////////////////////
	function themify_feed_settings( $data = array() ) {
		$data = themify_get_data();
		$checked_use = '';
		$feed_settings = themify_get( 'setting-feed_settings' );
		if ( themify_check( 'setting-exclude_img_rss' ) ) {
			$checked_use = 'checked="checked"';
		}
		return '<p><span class="label">' . __('Feed Category', 'themify') . '</span> <input type="text" class="width6" name="setting-feed_settings" value="'.$feed_settings.'" /></p>
				<p>
					<span class="pushlabel"><small>' . __('Use minus sign (-) to exclude categories.', 'themify') . '</small></span><br />
					<span class="pushlabel"><small>' . __('Example: (2,-9) = include only Category 2 in feeds and exclude Category 9.', 'themify') . '</small></span>
				</p>
				<p><span class="label">' . __('Post Image in RSS', 'themify') . '</span> <label for="setting-exclude_img_rss"><input type="checkbox" id="setting-exclude_img_rss" name="setting-exclude_img_rss" '.$checked_use.'/> ' . __('Exclude featured image in RSS feeds', 'themify') . '</label></p>
				<p>
					<span class="pushlabel"><small>' . __('Check this to exclude post image in RSS feeds', 'themify') . '</small></span>
				</p>
					';	
	}
	
	///////////////////////////////////////////
	// RSS Feed Settings Module - Action
	///////////////////////////////////////////
	function themify_feed_settings_action($query){
		$data = themify_get_data();
		if($query->is_feed){
			if(isset($data['setting-feed_settings'])){
				$query->set('cat',$data['setting-feed_settings']);	
			}
		}
		return $query;
	}
	add_filter('pre_get_posts','themify_feed_settings_action');

	///////////////////////////////////////
	// Filter RSS Feed to include post image - Action
	///////////////////////////////////////
	$themify_data = themify_get_data();
	if( !isset($themify_data['setting-exclude_img_rss']) || '' == $themify_data['setting-exclude_img_rss'] ){
		add_filter('the_content', 'themify_custom_fields_for_feeds');

	/* Firefox doesn't render images to feed when select full text from admin > Settings > Reading But IE does automatically for full text.
	 * So this code below will be used by firefox only to render/fetch images in feed. If we use for all then it will show images 2 times. */

		$useragent = $_SERVER['HTTP_USER_AGENT'];
		if(preg_match('|Firefox/([0-9\.]+)|',$useragent)) {
			add_filter('the_excerpt_rss', 'themify_custom_fields_for_feeds');
			add_filter('the_content_feed', 'themify_custom_fields_for_feeds');
		}

		function themify_custom_fields_for_feeds( $content ) {

			global $post, $id, $themify_check;
			if(!is_feed() || $themify_check == true){
				return $content;
			}

			if(themify_check('post_image')) {
				$content = "<p><img src='".themify_get('post_image')."'></p>" . $content;
			}
			$themify_check = false;
			return $content;
		}
	}
	
	///////////////////////////////////////////
	// Img Version / Settings
	///////////////////////////////////////////
	function themify_img_settings( $data = array() ) {
		
		/*** Img.php Crop Option Array ***/
		$options = array(
			array("value" => "c", "name" => __('Center', 'themify')),
			array("value" => "t", "name" => __('Top', 'themify')),
			array("value" => "tr",	"name" => __('Top Right', 'themify')),
			array("value" => "tl",	"name" => __('Top Left', 'themify')),
			array("value" => "b",	"name" => __('Bottom', 'themify')),
			array("value" => "br",	"name" => __('Bottom Right', 'themify')),
			array("value" => "bl",	"name" => __('Bottom Left', 'themify')),
			array("value" => "l",	"name" => __('Left', 'themify')),
			array("value" => "r",	"name" => __('Right', 'themify'))
		);
		$options_vertical = array(
			array('name'=> '',					 'value' => ''),
			array('name'=> __('Yes', 'themify'), 'value' => 'yes'),
			array('name'=> __('No', 'themify'),	 'value' => 'no')
		);
		$feature_sizes = array(
			array( 'value' => 'large', 'name' => __('Large', 'themify') ),
			array( 'value' => 'thumbnail', 'name' => __('Thumbnail', 'themify') ),
			array( 'value' => 'medium', 'name' => __('Medium', 'themify') ),
			array( 'value' => 'full', 'name' => __('Original Image', 'themify') )
		);
		$checked_use = '';
		if(themify_check('setting-img_settings_use')){
			$checked_use = "checked='checked'";
		}
		if(themify_check('setting-img_settings_legacy')){
			$checked_legacy = "checked='checked'";
		}
		$output = '<div class="module">
				<div class="label">img.php</div> 
				<div class="row">
					<label for="setting-img_settings_use"><input type="checkbox" id="setting-img_settings_use" name="setting-img_settings_use" class="disable_img_php" '.$checked_use.'/> ' . __('Disable img.php globally', 'themify') . '</label><br/>
					<span class="pushlabel"><small>' . __('(WordPress Featured Image or original images will be used)', 'themify') . '</small></span>
					<br/>
				</div>
				<div class="show_if_disabled_img_php">
					<div class="label">' . __('Default Featured Image Size', 'themify') . '</div>
					<div class="show_if_disabled_img_php row">
						<select name="setting-global_feature_size">';                                                                                              
						foreach($feature_sizes as $option){
							if($option['value'] == themify_get('setting-global_feature_size')){
								$output .= '<option value="'.$option['value'].'" selected="selected">';
									$output .= $option['name'];
								$output .= '</option>';
							} else {
								$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';
							}
						}
						$output .= '</select>
					</div>
				</div>
			<!-- BEGIN Show if img.php is enabled -->
			<div class="show_if_enabled_img_php">
				<div class="label">' . __('Image Quality', 'themify') . '</div> 
				<div class="row">
					<input class="width2" type="text" name="setting-img_settings_quality" value="'.themify_get('setting-img_settings_quality').'"> <small>' . __('max 100 (higher = better quality, but bigger file size)', 'themify') . '</small>
				</div>

				<div class="label">' . __('Cropping Alignment', 'themify') . '</div> 
				<div class="row">
					
					<select name="setting-img_settings_crop_option"><option></option>';
					foreach($options as $option){
						if($option['value'] == themify_get('setting-img_settings_crop_option')){
							$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';
						} else {
							$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';
						}
					}
		$output .= '</select></div>
				 <div class="label">' . __('Vertical Cropping', 'themify') . '</div> 
				<div class="row">
					
					<select name="setting-img_settings_vertical_crop_option">';
					foreach($options_vertical as $option_vertical){
						if($option_vertical['value'] == themify_get('setting-img_settings_vertical_crop_option')){
							$output .= '<option value="'.$option_vertical['value'].'" selected="selected">'.$option_vertical['name'].'</option>';
						} else {
							$output .= '<option value="'.$option_vertical['value'].'">'.$option_vertical['name'].'</option>';
						}
					}
		$output .= '</select> <small>' . __('(Select \'no\' to disable vertical cropping globally)', 'themify') . '</small></div>
		</div>
		<!-- END Show if img.php is enabled -->
				 </div>';
				 
		return $output;
	}

	
/* 	Styling Modules
/***************************************************************************/	
	
	///////////////////////////////////////////
	// Divider Module
	///////////////////////////////////////////
	function themify_divider( $data = array() ) {
		return '<hr/>';
	}
	
	///////////////////////////////////////////
	// Image Preview Module
	///////////////////////////////////////////
	function themify_image_preview( $data = array() ) {
		global $themify_config;
		$temp = themify_get_data();
		//Get currently selected preset
		$savedpath = themify_get( 'styling-'.$data['category'].'-'.$data['id'].'-background_image-value-value' );
		
		//Begin presets block
		$output = '<div class="preset">';

		// If it's activation, delete presets
		if( isset( $_GET['firsttime'] ) && $_GET['firsttime'] ) {
			delete_option('themify_background_presets');
		}

		//Check to see if we have already loaded the presets
		$presets = get_option('themify_background_presets');
		//var_dump($presets);
		if( false == $presets ){
			//if presets were not loaded, create a variable to store them
			$presets = array();

			//Presets first time
			if($data['attr']['src'] != ""){
				$img_folders = array('src' => $data['attr']['src']); 	
			} else {
				$img_folders = $themify_config['folders']['images'];
			}
			if(is_array($img_folders)){
				if(isset($img_folders['src'])){
					$folder = $img_folders['src'];
					if(is_dir(THEME_DIR.'/'.$folder)){
						if($handle = opendir(THEME_DIR.'/'.$folder)) {
							while (false !== ($file = readdir($handle))) {
								$ext = substr(strrchr($file, '.'), 1);
								if($ext == 'jpg' || $ext == 'gif' || $ext == 'png'){
									$fullpath = get_template_directory_uri()."/".$folder.$file;
									$is_selected = trim($fullpath) == trim($savedpath)? 'selected': '';
									$output .= '<a href="#" title="'.$folder.$file.'"><span title="'.$folder.$file.'"></span>
										<img src="'.$fullpath.'" alt="'.$fullpath.'" class="backgroundThumb '.$is_selected.'" /></a>';
									$presets[sanitize_file_name($file)] = $fullpath; 
								}
							}
							closedir($handle);
						}
					}
				} else {
					foreach($img_folders as $folder){
						$folder = $folder['src'];
						if(is_dir(THEME_DIR.'/'.$folder)){
							if($handle = opendir(THEME_DIR.'/'.$folder)) {
								while (false !== ($file = readdir($handle))) {
									$ext = substr(strrchr($file, '.'), 1);
									if($ext == 'jpg' || $ext == 'gif' || $ext == 'png'){
										$fullpath = get_template_directory_uri()."/".$folder.$file;
										$is_selected = trim($fullpath) == trim($savedpath)? 'selected': '';
										$output .= '<a href="#" title="'.$folder.$file.'"><span title="'.$folder.$file.'"></span>
										<img src="'.$fullpath.'" alt="'.$fullpath.'" class="backgroundThumb ' . $is_selected . '" /></a>';
										$output .= '<input type="hidden" name="preset' . sanitize_file_name($file) . '" value="' . $fullpath . '" />';
										$presets[sanitize_file_name($file)] = $fullpath;
									}
								}		
								closedir($handle);
							}
						}
					}
				}
			}
			//Presets first time END
			//var_dump($presets); //remove this!
			update_option( 'themify_background_presets', $presets );
		}
		else {
			//we have already stored our presets so go ahead and show them
			foreach ($presets as $file => $fullpath) {
				$is_selected = trim($fullpath) == trim($savedpath)? 'selected': '';
				$output .= '<a href="#" title="' . basename($file) . '"><span title="' . $file . '"></span><img src="' . $fullpath . '" alt="' . $fullpath . '" class="backgroundThumb ' . $is_selected . '" /></a>';
			}			
		}
		
		//End presets block
		$output .= '</div>';		
		return $output;
	}

	/**
	 * Refresh background presets
	 * @since 1.5.1
	 */
	function themify_delete_background_presets() {
		delete_option('themify_background_presets');
	}
	add_action( 'switch_theme', 'themify_delete_background_presets' );
	
	///////////////////////////////////////////
	// Background Image Module
	///////////////////////////////////////////
	function themify_background_image( $data = array() ) {
		if($data['attr']['target'] != ''){
			$target = "<span class='hide target'>".$data['attr']['target']."</span>";
		}
		$data['value'] = isset( $data['value']['value'] )? $data['value']['value'] : '';
		$data_value = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$none_checked = '';
		if ( isset( $data['value'] ) && isset( $data['value']['none'] ) && $data['value']['none'] ) {
			$none_checked = "checked='checked'";
		}
		$output = '<div class="themify_field_row background_image">
						<span class="label">' . __( 'Background Image', 'themify' ) . '</span> 
						'.$target.'
						<input type="text" name="styling-'.$data['category'].'-'.$data['id'].'-background_image-value-value" class="width8 upload-file" id="styling-'.$data['category'].'-'.$data['id'].'-background_image" value="'.$data_value.'" />
						<input type="checkbox" class="noBgImage" name="styling-'.$data['category'].'-'.$data['id'].'-background_image-value-none" '.$none_checked.' /> ' . __('No BG image', 'themify') . '<br /> 
						<div class="pushlabel" style="display:block;">
							'. 
			themify_get_uploader(
				'styling-'.$data['category'].'-'.$data['id'].'-background_image',
				array('preset' => true)
			)
							 . '
						</div>
					</div>';		
		return $output;
	}
	
	///////////////////////////////////////////
	// Background Color Module
	///////////////////////////////////////////
	function themify_background_color( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] )? $data['value']['value'] : '';
		$data_value = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		if ( isset( $data['value'] ) && isset( $data['value']['transparent'] ) && $data['value']['transparent'] ) {
			$output = '<div class="themify_field_row themify_field-background_color">
							<span class="label">' . __('Background Color', 'themify') . '</span>
						<div class="themify_field-color">
							<span class="colorSelect" style=""><span></span></span> <input type="text" disabled name="styling-'.$data['category'].'-'.$data['id'].'-background_color-value-value" class="colorSelectInput width4 opacity-7" /> 
							<input type="button" class="button clearColor" value="' . __('Clear', 'themify') . '">
							<input type="checkbox" checked="checked" name="styling-'.$data['category'].'-'.$data['id'].'-background_color-value-transparent" class="colorTransparent" /> ' . __('Transparent', 'themify') . '
						   </div>
						</div>';
		} else {
			$output = '
			<div class="themify_field_row themify_field-background_color">
				<span class="label">' . __('Background Color', 'themify') . '</span>
				<div class="themify_field-color"> 
					<span class="colorSelect "style="background-color:#'.$data_value.';"><span></span></span> <input type="text" name="styling-'.$data['category'].'-'.$data['id'].'-background_color-value-value" value="'.$data_value.'" class="colorSelectInput width4" />
					<input type="button" class="button clearColor" value="' . __('Clear', 'themify') . '"> 
					<input type="checkbox" name="styling-'.$data['category'].'-'.$data['id'].'-background_color-value-transparent" class="colorTransparent" /> ' . __('Transparent', 'themify') . '
				</div>
			</div>';
		}
		return $output;
	}
	
	///////////////////////////////////////////
	// Background Repeat Module
	///////////////////////////////////////////
	function themify_background_repeat( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] )? $data['value']['value'] : '';
		$options = array(
				array(
					'value' => 'repeat',
					'name' => __('Repeat', 'themify')
				),
				array(
					'value' => 'repeat-x',
					'name' => __('Repeat X', 'themify')
				),
				array(
					'value' => 'repeat-y',
					'name' => __('Repeat Y', 'themify')
				),
				array(
					'value' => 'no-repeat',
					'name' => __('Do not repeat', 'themify')
				)
			);
		$output = '<p><span class="label">' . __('Background Repeat', 'themify') . '</span>
					<select name="styling-'.$data['category'].'-'.$data['id'].'-background_repeat-value-value"><option> </option>';
		foreach($options as $option){
			$output .= '<option value="'.$option['value'].'" ' . selected( $option['value'], isset( $data['value']['value'] ) ? $data['value']['value'] : '', false ) . '>'.$option['name'].'</option>';
		}
		$output .=	'</select></p>';	
		return $output;
	}
	
	///////////////////////////////////////////
	// Background Position Module
	///////////////////////////////////////////
	function themify_background_position( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] )? $data['value']['value'] : '';
		$data_value_x = isset( $data['value']['x'] ) ? $data['value']['x'] : '';
		$data_value_y = isset( $data['value']['y'] ) ? $data['value']['y'] : '';
		$options = array(
				array(
					'value' => 'left',
					'name' => __('Left', 'themify')
				),
				array(
					'value' => 'center',
					'name' => __('Center', 'themify')
				),
				array(
					'value' => 'right',
					'name' => __('Right', 'themify')
				)
			);
		$output = '	<p><span class="label">' . __('Background Position', 'themify') . '</span> 
					<select class="background_position positionX"><option> </option>';
		foreach ( $options as $option ) {
			$output .= '<option value="'.$option['value'].'" ' . selected( $option['value'], $data_value_x, false ) . '>'.$option['name'].'</option>';	
		}
		$output .= '</select>
					<span class="value" style="display:none;">
						<input type="text" name="styling-'.$data['category'].'-'.$data['id'].'-background_position-value-x" value="'.$data_value_x.'" class="valueX">
					</span>';
		
		$options = array(
			array(
				'value' => 'top',
				'name' => __('Top', 'themify')
			),
			array(
				'value' => 'center',
				'name' => __('Center', 'themify')
			),
			array(
				'value' => 'bottom',
				'name' => __('Bottom', 'themify')
			)
		);
		$output .= '<select class="background_position positionY"><option> </option>';
		
		foreach ( $options as $option ) {
			$output .= '<option value="'.$option['value'].'" ' . selected( $option['value'], $data_value_y, false ) . '>'.$option['name'].'</option>';
		}
		$output .= '</select>
					<span class="value" style="display:none;">
						<input type="text" name="styling-'.$data['category'].'-'.$data['id'].'-background_position-value-y" value="'.$data_value_y.'" class="valueY">
					</span>
					</p>';
					
		return $output;
	}
	
	///////////////////////////////////////////
	// Font Family Module
	///////////////////////////////////////////
	function themify_font_family( $data = array() ) {
		global $themify_gfonts;
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$fonts = array("Arial, Helvetica, sans-serif",
						"Verdana, Geneva, sans-serif",
						"Georgia, \"Times New Roman\", Times, serif",
						"\"Times New Roman\", Times, serif",
						"Tahoma, Geneva, sans-serif",
						"\"Trebuchet MS\", Arial, Helvetica, sans-serif",
						"Palatino, \"Palatino Linotype\", \"Book Antiqua\", serif",
						"\"Lucida Sans Unicode\", \"Lucida Grande\", sans-serif");

		$output = '<p><span class="label">' . __('Font Family', 'themify') . '</span> 
					<select class="fontFamily" name="styling-'.$data['category'].'-'.$data['id'].'-font_family-value-value"><option> </option>';
		$output .= '<optgroup label="' . __('Web Safe Fonts', 'themify') . '">';
		foreach($fonts as $font){
			if ( isset( $data['value'] ) && isset( $data['value']['value'] ) && ( $font == $data['value']['value'] ) ) {
				$check = true;
				$output .= '<option value=\''.$font.'\' selected="selected">'.$font.'</option>';
			} else {
				$output .= '<option value=\''.$font.'\'>'.$font.'</option>';	
			}
		}
		$output .= '</optgroup>';

		if ( sizeof( $themify_gfonts ) > 0 ) {
			$output .= '<optgroup label="' . __('Google Fonts', 'themify') . '">';
			foreach ( $themify_gfonts as $font ) {
				$selected = ( isset( $data['value']['value'] ) ) && ( $font['family'] == $data['value']['value'] ) ? ' selected="selected"' : '';
				$output .= '<option value=\''.$font['family'].'\'' . $selected . '>'.$font['family'].'</option>';	
			}
			$output .= '</optgroup>';
		}

		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Font Size Module
	///////////////////////////////////////////
	function themify_font_size( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$data_value = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$options = array('px','em','%');
		$output = '<p><span class="label">' . __('Font Size', 'themify') . '</span> 
					<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-font_size-value-value" value="'.$data_value.'" />
					<select name="styling-'.$data['category'].'-'.$data['id'].'-font_size-value-unit"><option> </option>';
		foreach ( $options as $option ) {
			if ( isset( $data['value']['unit'] ) && ( $option == $data['value']['unit'] ) ) {
				$output .= '<option value="'.$option.'" selected="selected">'.$option.'</option>';
			} else {
				$output .= '<option value="'.$option.'">'.$option.'</option>';
			}
		}
		$output .=	'</select></p>';	
		return $output;
	}
	
	///////////////////////////////////////////
	// Font Weight Module
	///////////////////////////////////////////
	function themify_font_weight( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$options = array(
			array(
				'value' => 'normal',
				'name' => __('Normal', 'themify')
			),
			array(
				'value' => 'bold',
				'name' => __('Bold', 'themify')
			)
		);
		$output = '<p><span class="label">' . __('Font Weight', 'themify') . '</span> <select  name="styling-'.$data['category'].'-'.$data['id'].'-font_weight-value-value"><option> </option>';
		foreach($options as $option){
			if ( isset( $data['value']['value'] ) && ( $option['value'] == $data['value']['value'] ) ) {
				$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
			} else {
				$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
			}
		}
		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Font Style Module
	///////////////////////////////////////////
	function themify_font_style( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$options = array(
			array(
				'value' => 'normal',
				'name' => __('Normal', 'themify')
			),
			array(
				'value' => 'italic',
				'name' => __('Italic', 'themify')
			)
		);
		$output = '<p><span class="label">' . __('Font Style', 'themify') . '</span> <select name="styling-'.$data['category'].'-'.$data['id'].'-font_style-value-value"><option> </option>';
		foreach($options as $option){
			if ( isset( $data['value']['value'] ) && ( $option['value'] == $data['value']['value'] ) ) {
				$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
			} else {
				$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
			}
		}
		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Font Variant Module
	///////////////////////////////////////////
	function themify_font_variant( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$options = array(
			array(
				'value' => 'normal',
				'name' => __('Normal', 'themify')
			),
			array(
				'value' => 'small-caps',
				'name' => __('Small Caps', 'themify')
			)
		);
		$output = '<p><span class="label">' . __('Font Variant', 'themify') . '</span> <select name="styling-'.$data['category'].'-'.$data['id'].'-font_variant-value-value"><option> </option>';
		foreach($options as $option){
			if ( isset( $data['value']['value'] ) && ( $option['value'] == $data['value']['value'] ) ) {
				$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
			} else {
				$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
			}
		}
		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Line Height Module
	///////////////////////////////////////////
	function themify_line_height( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$data_value = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$options = array('px','em','%');
		$output = '	<p><span class="label">' . __('Line Height', 'themify') . '</span>
					<input type="text" class="width2 valid_num"  name="styling-'.$data['category'].'-'.$data['id'].'-line_height-value-value" value="'.$data_value.'" /><select name="styling-'.$data['category'].'-'.$data['id'].'-line_height-value-unit"><option> </option>';
		foreach($options as $option){
			if ( isset( $data['value']['unit'] ) && ( $option == $data['value']['unit'] ) ) {
				$output .= '<option value="'.$option.'" selected="selected">'.$option.'</option>';	
			} else {
				$output .= '<option value="'.$option.'">'.$option.'</option>';	
			}
		}
		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Text Transform Module
	///////////////////////////////////////////
	function themify_text_transform( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$options = array(
			array(
				'value' => 'capitalize',
				'name' => __('Capitalize', 'themify')
			),
			array(
				'value' => 'uppercase',
				'name' => __('Uppercase', 'themify')
			),
			array(
				'value' => 'lowercase',
				'name' => __('Lowercase', 'themify')
			),
			array(
				'value' => 'none',
				'name' => __('None', 'themify')
			)
		);
		$output = '	<p><span class="label">' . __('Text Transform', 'themify') . '</span> <select name="styling-'.$data['category'].'-'.$data['id'].'-text_transform-value-value"><option> </option>';
		foreach($options as $option){
			if ( isset( $data['value']['value'] ) && ( $option['value'] == $data['value']['value'] ) ) {
				$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
			} else {
				$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
			}
		}
		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Text Decoration Module
	///////////////////////////////////////////
	function themify_text_decoration( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$options = array(
			array(
				'value' => 'underline',
				'name' => __('Underline', 'themify')
			),
			array(
				'value' => 'overline',
				'name' => __('Overline', 'themify')
			),
			array(
				'value' => 'line-through',
				'name' => __('Line through', 'themify')
			),
			array(
				'value' => 'none',
				'name' => __('None', 'themify')
			)
		);
		$output = '	<p><span class="label">' . __('Text Decoration', 'themify') . '</span> <select name="styling-'.$data['category'].'-'.$data['id'].'-text_decoration-value-value"><option> </option>';
		foreach($options as $option){
			if ( isset( $data['value']['value'] ) && ( $option['value'] == $data['value']['value'] ) ) {
				$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
			} else {
				$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
			}
		}
		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Font Color Module
	///////////////////////////////////////////
	function themify_color( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$data_value = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		return '<div class="themify_field_row">
					<span class="label">' . __('Color', 'themify') . '</span>
					<div class="themify_field-color">
						<span class="colorSelect" style="background:#'.$data_value.';">
							<span></span>
						</span>
						<input type="text" class="colorSelectInput width4" value="'.$data_value.'" name="styling-'.$data['category'].'-'.$data['id'].'-color-value-value" />
						<input type="button" class="button clearColor" value="' . __('Clear', 'themify') . '">
					</div>
				</div>';
	}
	
	///////////////////////////////////////////
	// Padding Module
	///////////////////////////////////////////
	function themify_padding( $data = array() ) {
		$individuals = '';
		$checked = '';
		$same = '';
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$data_value_same = isset( $data['value']['same'] ) ? $data['value']['same'] : '';
		$data_value_top = isset( $data['value']['top'] ) ? $data['value']['top'] : '';
		$data_value_right = isset( $data['value']['right'] ) ? $data['value']['right'] : '';
		$data_value_bottom = isset( $data['value']['bottom'] ) ? $data['value']['bottom'] : '';
		$data_value_left = isset( $data['value']['left'] ) ? $data['value']['left'] : '';
		
		if ( isset( $data['value'] ) && isset( $data['value']['checkbox'] ) && $data['value']['checkbox'] ) {
			$checked = "checked='checked'";
			$individuals = "style='display:none;'";	
		} else {
			$same = "style='display:none;'";
		}
		$output = '<div>
						<p>
							<span class="label">' . __('Padding', 'themify') . '</span>
							<span class="same" '.$same.'>
								<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-padding-value-same" value="'.$data_value_same.'" /> <small>px</small>
							</span>
							<span class="individuals" '.$individuals.'>
								<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-padding-value-top" value="'.$data_value_top.'" /> top 
								<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-padding-value-right" value="'.$data_value_right.'" /> right 
								<input type="text" class="width2 valid_num"  name="styling-'.$data['category'].'-'.$data['id'].'-padding-value-bottom" value="'.$data_value_bottom.'"/> bottom 
								<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-padding-value-left" value="'.$data_value_left.'" /> left <small>(px)</small>
							</span>
						</p>
						<p>
							<span class="pushlabel" style="display:block;">
								<input type="checkbox" name="styling-'.$data['category'].'-'.$data['id'].'-padding-value-checkbox" class="padding-switch" '.$checked.' /> ' . __('Same for all', 'themify') . ' 
							</span>
						</p>
					</div>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Margin Module
	///////////////////////////////////////////
	function themify_margin( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$data_value_name = isset( $data['value']['same'] ) ? $data['value']['same'] : '';
		$data_value_top = isset( $data['value']['top'] ) ? $data['value']['top'] : '';
		$data_value_right = isset( $data['value']['right'] ) ? $data['value']['right'] : '';
		$data_value_bottom = isset( $data['value']['bottom'] ) ? $data['value']['bottom'] : '';
		$data_value_left = isset( $data['value']['left'] ) ? $data['value']['left'] : '';
		$individuals = '';
		$checked = '';
		$same = '';
		if ( isset( $data['value'] ) && isset( $data['value']['checkbox'] ) && $data['value']['checkbox'] ) {
			$checked = "checked='checked'";
			$individuals = "style='display:none;'";	
		} else {
			$same = "style='display:none;'";
		}
		$output = '<div>
						<p>
							<span class="label">' . __('Margin', 'themify') . '</span>';
		$output .= '<span class="same" '.$same.'>
						<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-margin-value-same" value="'.$data_value_name.'" /> <small>px</small>
					</span>
					<span class="individuals" '.$individuals.'>
						<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-margin-value-top" value="'.$data_value_top.'" /> top 
						<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-margin-value-right" value="'.$data_value_right.'" /> right 
						<input type="text" class="width2 valid_num"  name="styling-'.$data['category'].'-'.$data['id'].'-margin-value-bottom" value="'.$data_value_bottom.'"/> bottom 
						<input type="text" class="width2 valid_num" name="styling-'.$data['category'].'-'.$data['id'].'-margin-value-left" value="'.$data_value_left.'" /> left <small>(px)</small>
					</span>
				</p>
				<p>
					<span class="pushlabel" style="display:block;">
						<input type="checkbox" name="styling-'.$data['category'].'-'.$data['id'].'-margin-value-checkbox" '.$checked.' class="margin-switch" /> ' . __('Same for all', 'themify') . ' 
					</span>
				</p>
			</div>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Height Module
	///////////////////////////////////////////
	function themify_height( $data = array() ) {
		$value = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$value['value'] = isset( $value['value'] ) ? $value['value'] : '';
		$value['unit'] = isset( $value['unit'] ) ? $value['unit'] : '';
		
		$options = array('px','em','%');
		$output = '	<p><span class="label">' . __('Height', 'themify') . '</span> 
					<input type="text" class="width2 valid_num" value="'.$value['value'].'" name="styling-'.$data['category'].'-'.$data['id'].'-height-value-value" />  
					<select name="styling-'.$data['category'].'-'.$data['id'].'-height-value-unit"><option> </option>';
		foreach($options as $option){
			if($option == $value['unit']){
				$output .= '<option value="'.$option.'" selected="selected">'.$option.'</option>';	
			} else {
				$output .= '<option value="'.$option.'">'.$option.'</option>';	
			}
		}
		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Width Module
	///////////////////////////////////////////
	function themify_width( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$options = array('px','em','%');
		$output = '	<p><span class="label">' . __('Width', 'themify') . '</span> 
					<input type="text" class="width2 valid_num" value="'.$data['value'].'" name="styling-'.$data['category'].'-'.$data['id'].'-width-value-value" />  
					<select name="styling-'.$data['category'].'-'.$data['id'].'-width-value-unit"><option> </option>';
		foreach($options as $option){
			if($option == $data['value']['unit']){
				$output .= '<option value="'.$option.'" selected="selected">'.$option.'</option>';	
			} else {
				$output .= '<option value="'.$option.'">'.$option.'</option>';	
			}
		}
		$output .= '</select></p>';
		return $output;
	}
	
	///////////////////////////////////////////
	// Border Module
	///////////////////////////////////////////
	function themify_border( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$individuals = '';
		$checked = '';
		$same = '';
		if ( isset( $data['value'] ) && isset( $data['value']['checkbox'] ) && $data['value']['checkbox'] ) {
			$checked = "checked='checked'";
			$individuals = "style='display:none;'";	
		} else {
			$same = "style='display:none;'";
		}
		$options = array(
			array(
				'value' => 'solid',
				'name' => __('Solid', 'themify')
			),
			array(
				'value' => 'dashed',
				'name' => __('Dashed', 'themify')
			),
			array(
				'value' => 'dotted',
				'name' => __('Dotted', 'themify')
			),
			array(
				'value' => 'double',
				'name' => __('Double', 'themify')
			)
		);
		$data_value_same = isset( $data['value']['same'] ) ? $data['value']['same'] : '';
		$data_value_same_color = isset( $data['value']['same_color'] ) ? $data['value']['same_color'] : '';
		$data_value_top_color = isset( $data['value']['top_color'] ) ? $data['value']['top_color'] : '';
		$data_value_top = isset( $data['value']['top'] ) ? $data['value']['top'] : '';
		$data_value_right_color = isset( $data['value']['right_color'] ) ? $data['value']['right_color'] : '';
		$data_value_right = isset( $data['value']['right'] ) ? $data['value']['right'] : '';
		$data_value_bottom_color = isset( $data['value']['bottom_color'] ) ? $data['value']['bottom_color'] : '';
		$data_value_bottom = isset( $data['value']['bottom'] ) ? $data['value']['bottom'] : '';
		$data_value_left_color = isset( $data['value']['left_color'] ) ? $data['value']['left_color'] : '';
		$data_value_left = isset( $data['value']['left'] ) ? $data['value']['left'] : '';
		$output = '<div><p>
						<span class="label">' . __('Border', 'themify') . '</span> 
						<span class="same" '.$same.'>
							<span class="colorSelect" style="background-color:#'.$data_value_same_color.'"><span></span></span>  <input type="text" value="'.$data_value_same_color.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-same_color" class="width4 colorSelectInput" /> 
							<input type="text" class="width2 valid_num" value="'.$data_value_same.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-same" /> <small>px</small> 
							<select name="styling-'.$data['category'].'-'.$data['id'].'-border-value-same_style"><option> </option>';
							foreach ( $options as $option ) {
								if ( isset( $data['value']['same_style'] ) && ( $option['value'] == $data['value']['same_style'] ) ) {
									$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
								} else {
									$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
								}
							}
		$output .= '		</select>
						</span>
						<span class="individuals" '.$individuals.'>
						<span class="borders">
							<span class="colorSelect" style="background-color:#'.$data_value_top_color.';"><span></span></span> <input type="text" value="'.$data_value_top_color.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-top_color" class="width4 colorSelectInput" /> 
							<input type="text" class="width2 valid_num" value="'.$data_value_top.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-top" /> <small>px</small>
							<select name="styling-'.$data['category'].'-'.$data['id'].'-border-value-top_style"><option> </option>';
							foreach ( $options as $option ) {
								if ( isset( $data['value']['top_style'] ) && ( $option['value'] == $data['value']['top_style'] ) ) {
									$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
								} else {
									$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
								}
							}
		$output .= '		</select> ' . __('top', 'themify') . '
						</span>
						<span class="pushlabel borders" style="display:block;">
							<span class="colorSelect" style="background-color:#'.$data_value_right_color.';"><span></span></span> <input type="text" value="'.$data_value_right_color.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-right_color" class="width4 colorSelectInput" /> 
							<input type="text" class="width2 valid_num" value="'.$data_value_right.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-right" /> <small>px</small>
							<select name="styling-'.$data['category'].'-'.$data['id'].'-border-value-right_style"><option> </option>';
							foreach ( $options as $option ) {
								if ( isset( $data['value']['right_style'] ) && ( $option['value'] == $data['value']['right_style'] ) ) {
									$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
								} else {
									$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
								}
							}
		$output .= '		</select> ' . __('right', 'themify') . '
						</span>
						<span class="pushlabel borders" style="display:block;">
							<span class="colorSelect" style="background-color:#'.$data_value_bottom_color.';"><span></span></span> <input type="text" value="'.$data_value_bottom_color.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-bottom_color" class="width4 colorSelectInput" /> 
							<input type="text" class="width2 valid_num" value="'.$data_value_bottom.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-bottom" /> <small>px</small>
							<select name="styling-'.$data['category'].'-'.$data['id'].'-border-value-bottom_style"><option> </option>';
							foreach ( $options as $option ) {
								if ( isset( $data['value']['bottom_style'] ) && ( $option['value'] == $data['value']['bottom_style'] ) ) {
									$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
								} else {
									$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
								}
							}
		$output .= '		</select> ' . __('bottom', 'themify') . '
						</span>
						<span class="pushlabel borders" style="display:block;">
							<span class="colorSelect" style="background-color:#'.$data_value_left_color.';"><span></span></span> <input type="text" value="'.$data_value_left_color.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-left_color" class="width4 colorSelectInput" /> 
							<input type="text" class="width2 valid_num" value="'.$data_value_left.'" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-left" /> <small>px</small>
							<select name="styling-'.$data['category'].'-'.$data['id'].'-border-value-left_style"><option> </option>';
							foreach ( $options as $option ) {
								if ( isset( $data['value']['left_style'] ) && ( $option['value'] == $data['value']['left_style'] ) ) {
									$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
								} else {
									$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
								}
							}
		$output .= '		</select> ' . __('left', 'themify') . '
						</span>
					</span>
					</p>
					<p>
						<span class="pushlabel" style="display:block;">
							<input type="checkbox" class="border-switch" name="styling-'.$data['category'].'-'.$data['id'].'-border-value-checkbox" '.$checked.' /> ' . __('Same for all', 'themify') . '
						</span>
					</p>
				</div>';				
		return $output;
	}
	
	///////////////////////////////////////////
	// Position Module
	///////////////////////////////////////////
	function themify_position( $data = array() ) {
		$data['value'] = isset( $data['value']['value'] ) ? $data['value']['value'] : '';
		$data_value_x_value = isset( $data['value']['x_value'] ) ? $data['value']['x_value'] : '';
		$data_value_y_value = isset( $data['value']['y_value'] ) ? $data['value']['y_value'] : '';
		$options = array(
			array(
				'value' => 'static',
				'name' => __('static', 'themify')
			),
			array(
				'value' => 'fixed',
				'name' => __('fixed', 'themify')
			),
			array(
				'value' => 'relative',
				'name' => __('relative', 'themify')
			),
			array(
				'value' => 'absolute',
				'name' => __('absolute', 'themify')
			),
			
		);
		$options_x = array(
			array(
				'value' => 'top',
				'name' => __('top', 'themify')
			),
			array(
				'value' => 'bottom',
				'name' => __('bottom', 'themify')
			),			
		);
		$options_y = array(
			array(
				'value' => 'left',
				'name' => __('left', 'themify')
			),
			array(
				'value' => 'right',
				'name' => __('right', 'themify')
			)
		);
		if ( $data['value'] != 'fixed' && $data['value'] != 'absolute' ) {
			$display = "style='display:none;'";	
		}
		$output = '	<p><span class="label">' . __('Position', 'themify') . '</span>
					<select name="styling-'.$data['category'].'-'.$data['id'].'-position-value-value" class="select_position"><option> </option>';
		foreach ( $options as $option ) {
			if ( $option['value'] == $data['value'] ) {
				$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
			} else {
				$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
			}
		}
		$output .= '</select></p>
					<p class="position_display" '.$display.'>
						<span class="pushlabel" style="display:block;">
						<select name="styling-'.$data['category'].'-'.$data['id'].'-position-value-x"><option> </option>';
						foreach ( $options_x as $option ) {
							if ( isset( $data['value']['x'] ) && ( $option['value'] == $data['value']['x'] ) ) {
								$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
							} else {
								$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
							}
						}	
		$output .=	'	</select>
						<input type="text" class="width2 valid_num" value="'.$data_value_x_value.'" name="styling-'.$data['category'].'-'.$data['id'].'-position-value-x_value" /> <small>px</small> 
						</span>
						<span class="pushlabel" >
						<select name="styling-'.$data['category'].'-'.$data['id'].'-position-value-y"><option> </option>';
						foreach ( $options_y as $option ) {
							if ( isset( $data['value']['y'] ) && ( $option['value'] == $data['value']['y'] ) ) {
								$output .= '<option value="'.$option['value'].'" selected="selected">'.$option['name'].'</option>';	
							} else {
								$output .= '<option value="'.$option['value'].'">'.$option['name'].'</option>';	
							}
						}	
		$output .=	'	</select>
						<input type="text" class="width2 valid_num" value="'.$data_value_y_value.'" name="styling-'.$data['category'].'-'.$data['id'].'-position-value-y_value" /> <small>px</small> 
						</span>
					</p>';
		return $output;	
	}

/**
 * Outputs module for user to select whether to use a lightbox or not. The lightbox choices can be filtered using the 'themify_lightbox_module_options' filter in a custom-functions.php file.
 * @param array $data
 * @return string
 * @since 1.2.5
 */
function themify_gallery_plugins( $data = array() ) {

	$display_options = apply_filters('themify_lightbox_module_options', array(
		__( 'prettyPhoto (lightbox)', 'themify' ) => 'prettyphoto',
		__( 'photoSwipe (fullscreen swipe)', 'themify' ) => 'photoswipe',
		__( 'None', 'themify' ) => 'none'
	));

	$gallery_lightbox = themify_get( 'setting-gallery_lightbox' );

	$out = '<p>
				<span class="label">' . __( 'WordPress Gallery', 'themify' ) . ' </span>
				<select name="setting-gallery_lightbox">';
				foreach ( $display_options as $option => $value ) {
					$out .= '<option value="'.$value.'" '.selected( $value? $value: 'prettyPhoto', $gallery_lightbox, false ).'>'.$option.'</option>';
				}
	$out .= '	</select>
			</p>';
	$out .= '<p>
				<span class="pushlabel"><label for="setting-lightbox_content_images">
					<input type="checkbox" id="setting-lightbox_content_images" name="setting-lightbox_content_images" '. checked( themify_get( 'setting-lightbox_content_images' ), 'on', false ) .'/> ' . __('Apply lightbox to image links (ie. links to jpg, png, and gif will open in lightbox)', 'themify') . '</label>
				</span>
			</p>';
	return $out;
}

/**
 * Template to display a link in Links module, also used when creating a link.
 * @param array $data
 * @return string
 * @since 1.2.7
 */
function themify_add_link_template( $fid, $data = array(), $ajax = false ) {
	$pre = 'setting-link_';
	
	$title_name = $pre.'title_'.$fid;
	$title_val = isset($data[$title_name])? $data[$title_name] : '';
	
	$link_name = $pre.'link_'.$fid;
	$link_val = isset($data[$link_name])? $data[$link_name] : '';
	
	$img_name = $pre.'img_'.$fid;
	$img_val = '' == $data[$img_name] || !isset($data[$img_name]) ? '' : $data[$img_name];
	
	if($ajax){
		$hide = '';
	} else {
		$hide = '';
	}
	
	$field = '<li id="%s" class="social-link-item" %s>
				<div class="row">
					<span class="label">%s</span> <input type="text" name="%s" class="width6" value="%s">
				</div>
				<!-- /row -->
				<div class="row">
					<span class="label">%s</span> <input type="text" name="%s" class="width10" value="%s">
				</div>
				<!-- /row -->
				<div class="row">
					<span class="label">%s</span>
					<div class="uploader-fields image">
						<input type="text" id="%s" name="%s" class="width10" value="%s">
						<div class="clear image">%s</div>
					</div>
				</div>
				<!-- /row -->
				<div class="icon-preview">
					<img id="%s" src="%s" /> 
				</div>
				<!-- /icon-preview -->
				<a href="#" class="remove-item" data-removelink="%s">%s</a>
			</li>
			<!-- /social-links-item -->';

	$out = sprintf(
		$field, // field html template
			$fid, // link item ID
			$hide, // hide if it's called from ajax
			__( 'Title', 'themify' ), $title_name, trim($title_val),
			__( 'Link', 'themify' ), $link_name, trim($link_val),
			__( 'Image', 'themify' ), $img_name, $img_name, $img_val,
			themify_get_uploader( $img_name, array( 'tomedia' => true, 'preview' => true ) ),
			$img_name.'-preview', $img_val, // thumbnail
			$fid,
			__( 'Remove', 'themify' )
	);
	return $out;
}

/**
 * Outputs module to manage links to be shown using the corresponding widget
 * @param array $data
 * @return string
 * @since 1.2.7
 */
function themify_manage_links( $data = array() ) {
	$data = themify_get_data();
	$pre = 'setting-link_';
	$field_hash = isset( $data[$pre.'field_hash'] ) && $data[$pre.'field_hash'] ? $data[$pre.'field_hash'] : 5;
	$start = array();
	for ( $i=0; $i < $field_hash; $i++ ) {
		$start['themify-link-'.$i] = 'themify-link-'.$i;
	}
	//$data[$pre.'field_ids'] = json_encode($start);
	
	if ( json_decode( $data[$pre.'field_ids'] ) ) {
		$field_ids = json_decode( $data[$pre.'field_ids'] );
	} else {
		$field_ids = $start;

		$data[$pre.'title_themify-link-0'] = 'Twitter';
		$data[$pre.'title_themify-link-1'] = 'Facebook';
		$data[$pre.'title_themify-link-2'] = 'Google+';
		$data[$pre.'title_themify-link-3'] = 'YouTube';
		$data[$pre.'title_themify-link-4'] = 'Pinterest';
		
		$data[$pre.'link_themify-link-0'] = '';
		$data[$pre.'link_themify-link-1'] = '';
		$data[$pre.'link_themify-link-2'] = '';
		$data[$pre.'link_themify-link-3'] = '';
		$data[$pre.'link_themify-link-4'] = '';
		
		$data[$pre.'img_themify-link-0'] = THEMIFY_URI . '/img/social/twitter.png';
		$data[$pre.'img_themify-link-1'] = THEMIFY_URI . '/img/social/facebook.png';
		$data[$pre.'img_themify-link-2'] = THEMIFY_URI . '/img/social/google-plus.png';
		$data[$pre.'img_themify-link-3'] = THEMIFY_URI . '/img/social/youtube.png';
		$data[$pre.'img_themify-link-4'] = THEMIFY_URI . '/img/social/pinterest.png';
		
		$data = apply_filters('themify_default_social_links', $data);
	}
	
	$out =  '<ul id="social-links-wrapper">';
		foreach ( $field_ids as $key => $fid ) {
			$out .= themify_add_link_template( $fid, $data );
		}
	$out .= '</ul>';
	
	$out .= '<p class="add-social-link"><a href="#">' . __('Add Link', 'themify') . '</a></p>';
	$out .= '<p><small>' . sprintf( __( 'To display the links: go to Appearance > <a href="%s">Widgets</a> and drop a Themify - Social Links widget in a widget area (<a href="%s">learn more</a>)', 'themify' ), admin_url('widgets.php'), 'http://themify.me/docs/social-media-links') . '</small></p>';
	$out .= '<input type="hidden" id="'.$pre.'field_ids" name="'.$pre.'field_ids" value=\'' . json_encode( $field_ids ) . '\'/>';
	$out .= '<input type="hidden" id="'.$pre.'field_hash" name="'.$pre.'field_hash" value="'.$field_hash.'"/>';
	//$out .= '<p>Fields: '.json_encode($field_ids).'</p><p>Hash: '.$field_hash.'</p>';
	
	return $out;
}

/**
 * Disables Open Graph tags
 * @param array $data
 * @return string $out Markup for option
 */
function themify_open_graph_options($data = array()){
	$data = themify_get_data();
	$pre = 'setting-og_';

	$out = '<p>
				<span><label for="'.$pre.'disable">
					<input type="checkbox" id="'.$pre.'disable" name="'.$pre.'disable" '. checked(isset( $data[$pre.'disable'] )? $data[$pre.'disable']: '', 'on', false) .'/> ' . __('Remove Open Graph Tags', 'themify') . '</label>
				</span>
			</p>';
	return $out;
}

/**
 * Outputs post meta options
 * @param string $pmkey Key used to get data from theme settings array
 * @param array $data Theme settings data
 * @param array $metas Optional array stating the metas available.
 * @return string $out Markup for options
 */
function themify_post_meta_options( $pmkey, $data, $metas = array(), $states = array(), $group_label = false ) {
	
	if ( empty($metas ) ) {
		$metas = array (
			''			=> __( 'Hide All', 'themify' ),
	 		'author' 	=> __( 'Author', 'themify' ),
	 		'category' 	=> __( 'Category', 'themify' ),
	 		'comment' 	=> __( 'Comment', 'themify' ),
	 		'tag' 		=> __( 'Tag', 'themify' )
		);
	}
	if ( empty( $states ) ) {
		$states = array(
			array(
				'name' => __( 'Hide', 'themify' ),
				'value' => 'yes',
				'icon' => THEMIFY_URI . '/img/ddbtn-check.png',
				'title' => __( 'Hide this meta', 'themify' )
			),
			array(
				'name' => __( 'Do not hide', 'themify' ),
				'value' => 'no',
				'icon' => THEMIFY_URI . '/img/ddbtn-cross.png',
				'title' => __( 'Show this meta', 'themify' )
			)
		);
	}
	if ( ! $group_label ) {
		$group_label = __( 'Hide Post Meta', 'themify' );
	}
	
	$default = array(
		'name' => __( 'Theme', 'themify' ),
		'value' => '',
		'icon' => THEMIFY_URI . '/img/ddbtn-blank.png',
		'title' => __( 'Use theme settings', 'themify' )
	);
	
	$out = '<div class="themify_field_row dropdownbutton-group"><span class="label">' . $group_label . '</span>';
					
			foreach ( $metas as $meta => $name ) {
				if ( '' == $meta ) {
					$metakey = $pmkey;
					$meta_class = 'ddbtn-all';
				} else {
					$metakey = $pmkey.'_'.$meta;
					$meta_class = 'ddbtn-sub ddbtn-'.$meta;
				}
				$first = '';
				$others = '';
				$out .=	'
				<div id="'.$metakey.'" class="dropdownbutton-list" data-name="'.$name.'" data-def-icon="'.$default['icon'].'">';
				
				// default state
				$first = '
					<div class="first-ddbtn">
						<a href="#" data-val="'.$default['value'].'" data-name="'.$default['name'].'" title="'.$default['title'].'">
							<img src="'.$default['icon'].'" title="'.$default['title'].'" />
							<span class="ddbtn-name">'.$name.'</span>
						</a>
					</div>';

				foreach ( $states as $state ) {
					if ( isset( $state['value'] ) && isset( $data[$metakey] ) && $state['value'] == $data[$metakey] ) {
						$first = '
						<div class="first-ddbtn">
							<a href="#" data-val="'.$state['value'].'" data-name="'.$state['name'].'" title="'.$state['title'].'">
								<img src="'.$state['icon'].'" title="'.$state['title'].'" />
								<span class="ddbtn-name">'.$name.'</span>
							</a>
						</div>';
						$selected = 'selected';
						//$hide = 'ddbtn-hide';
						$hide = '';
					} else {
						$selected = '';
						$hide = '';
					}
					
					$others .= '
						<div class="ddbtn '.$hide.'">
							<a href="#" data-sel="'.$selected.'" data-val="'.$state['value'].'" data-name="'.$state['name'].'" title="'.$state['title'].'">
								<img src="'.$state['icon'].'" title="'.$state['title'].'" />
								<span class="ddbtn-label">'.$state['name'].'</span>
							</a>
						</div>';
				}
				$out .= $first . '<div class="dropdownbutton">' . $others . '</div>';
				$out .= '
				</div>';
				$meta_key_data = themify_get( $metakey );
				$out .= '<input type="hidden" value="'.$meta_key_data.'" class="'.$meta_class.'" id="'.$metakey.'" name="'.$metakey.'" />';
			}

	$out .= '</div>';
	return $out;
}

/**
 * Outputs post sorting options
 * @param string $key Key used to get data from theme settings array
 * @param array $data Theme settings data
 * @return string $out Markup for options
 */
if ( ! function_exists( 'themify_post_sorting_options' ) ) {
	function themify_post_sorting_options( $key = 'setting-index_order', $data ) {

		$orderby = themify_get( $key . 'by' );
		$orderby_options = apply_filters( 'themify_index_orderby_options', array(
			__( 'Date (default)', 'themify' ) => 'date',
			__( 'Random', 'themify' ) => 'rand',
			__( 'Author', 'themify' ) => 'author',
			__( 'Post Title', 'themify' ) => 'title',
			__( 'Comments Number', 'themify' ) => 'comment_count',
			__( 'Modified Date', 'themify' ) => 'modified',
			__( 'Post Slug', 'themify' ) => 'name',
			__( 'Post ID', 'themify' ) => 'ID' ) );

		$order = themify_get( $key );
		$order_options = array(
			__( 'Descending (default)', 'themify' ) => 'DESC',
			__( 'Ascending', 'themify' ) => 'ASC' );

		$out = '<p>
					<span class="label">' . __( 'Order By', 'themify' ) . ' </span>
					<select name="'.$key.'by">';
						foreach ( $orderby_options as $option => $value ) {
							$out .= '<option value="'.$value.'" '.selected( $value? $value: 'date', $orderby, false ).'>'.$option.'</option>';
							}
		$out .= '	</select>
				</p>
				<p>
					<span class="label">' . __( 'Order', 'themify' ) . ' </span>
					<select name="'.$key.'">';
						foreach ( $order_options as $option => $value ) {
							$out .= '<option value="'.$value.'" '.selected( $value? $value: 'DESC', $order, false ).'>'.$option.'</option>';
					}
		$out .= '	</select>
				</p>';

		return $out;
	}
}

if ( ! function_exists( 'themify_homepage_welcome' ) ) {
	/**
	 * Homepage Welcome Function
	 * @return string Markup for welcome text control
	 */
	function themify_homepage_welcome() {
		return '<p><textarea class="widthfull" name="setting-homepage_welcome" rows="4">' . themify_get( 'setting-homepage_welcome' ) . '</textarea></p>';
	}
}

if ( ! function_exists( 'themify_exclude_rss' ) ) {
	/**
	 * Exclude RSS
	 * @return string
	 */
	function themify_exclude_rss() {
		return '<p><label for="setting-exclude_rss"><input type="checkbox" id="setting-exclude_rss" name="setting-exclude_rss" ' . checked( themify_get( 'setting-exclude_rss' ), 'on', false ) . '/> ' . __( 'Check here to exclude RSS icon/button', 'themify' ) . '</label></p>';	
	}
}

if ( ! function_exists( 'themify_exclude_search_form' ) ) {
	/**
	 * Exclude Search Form
	 * @return string
	 */
	function themify_exclude_search_form() {
		return '<p><label for="setting-exclude_search_form"><input type="checkbox" id="setting-exclude_search_form" name="setting-exclude_search_form" ' . checked( themify_get( 'setting-exclude_search_form' ), 'on', false ) . '/> ' . __( 'Check here to exclude search form', 'themify' ) . '</label></p>';	
	}
}

if ( ! function_exists( 'themify_footer_text_left' ) ) {
	/**
	 * Footer Text Left Function
	 * @return string
	 */
	function themify_footer_text_left() {
		return '<p><textarea class="widthfull" rows="4" name="setting-footer_text_left">' . themify_get( 'setting-footer_text_left' ) . '</textarea></p>';
	}
}

if ( ! function_exists( 'themify_footer_text_right' ) ) {
	/**
	 * Footer Text Right Function
	 * @param array $data
	 * @return string
	 */
	function themify_footer_text_right(){
		return '<p><textarea class="widthfull" rows="4" name="setting-footer_text_right">' . themify_get( 'setting-footer_text_right' ) . '</textarea></p>';
	}
}

if(!function_exists('themify_homepage_widgets')){
	/**
	 * Widgets module function
	 * @param string $key Widgets group option key.
	 * @param array $options Options for module
	 * @return string Module markup
	 */
	function themify_homepage_widgets(){
		$data = themify_get_data();
		$val = isset($data['setting-homepage_widgets'])? $data['setting-homepage_widgets'] : null;
		$options = array(
			array(
				'value' => 'homewidget-4col',
				'img' => 'themify/img/sidebars/4col.png',
				'title' => __('Widgets 4 Columns', 'themify')),
			array(
				'value' => 'homewidget-3col',
				'img' => 'themify/img/sidebars/3col.png',
				'title' => __('Widgets 3 Columns', 'themify'),
				'selected' => true),
			array(
				'value' => 'homewidget-2col',
				'img' => 'themify/img/sidebars/2col.png',
				'title' => __('Widgets 3 Columns', 'themify')),
			array(
				'value' => 'homewidget-1col',
				'img' => 'themify/img/sidebars/1col.png',
				'title' => __('Widgets 1 Column', 'themify')),
			array(
				'value' => 'none',
				'img' => 'themify/img/sidebars/none.png',
				'title' => __('No Widgets', 'themify'))
		);
		$output = '';
		foreach($options as $option){
			if(('' == $val || !$val || !isset($val)) && isset($option['selected']) && $option['selected']){ 
				$val = $option['value'];
			}
			if($val == $option['value']){ 
				$class = 'selected';
			} else {
				$class = '';
			}
			$output .= '<a href="#" class="preview-icon '.$class.'" title="'.$option['title'].'"><img src="'.THEME_URI.'/'.$option['img'].'" alt="'.$option['value'].'"  /></a>';	
		}
		$output .= '<input type="hidden" name="setting-homepage_widgets" class="val" value="'.$val.'" />';
		return $output;
	}
}

if(!function_exists('themify_footer_widgets')){
	/**
	 * Widgets module function
	 * @param string $key Widgets group option key.
	 * @param array $options Options for module
	 * @return string Module markup
	 */
	function themify_footer_widgets(){
		$data = themify_get_data();
		$val = isset($data['setting-footer_widgets'])? $data['setting-footer_widgets'] : null;
		$options = array(
			array(
				'value' => 'footerwidget-4col',
				'img' => 'themify/img/sidebars/4col.png',
				'title' => __('Widgets 4 Columns', 'themify')),
			array(
				'value' => 'footerwidget-3col',
				'img' => 'themify/img/sidebars/3col.png',
				'title' => __('Widgets 3 Columns', 'themify'),
				'selected' => true),
			array(
				'value' => 'footerwidget-2col',
				'img' => 'themify/img/sidebars/2col.png',
				'title' => __('Widgets 2 Columns', 'themify')),
			array(
				'value' => 'footerwidget-1col',
				'img' => 'themify/img/sidebars/1col.png',
				'title' => __('Widgets 1 Column', 'themify')),
			array(
				'value' => 'none',
				'img' => 'themify/img/sidebars/none.png',
				'title' => __('No Widgets', 'themify'))
		);
		$output = '';
		foreach($options as $option){
			if(('' == $val || !$val || !isset($val)) && isset($option['selected']) && $option['selected']){ 
				$val = $option['value'];
			}
			if($val == $option['value']){ 
				$class = 'selected';
			} else {
				$class = '';
			}
			$output .= '<a href="#" class="preview-icon '.$class.'" title="'.$option['title'].'"><img src="'.THEME_URI.'/'.$option['img'].'" alt="'.$option['value'].'"  /></a>';	
		}
		$output .= '<input type="hidden" name="setting-footer_widgets" class="val" value="'.$val.'" />';
		return $output;
	}
}

if(!function_exists('themify_manage_twitter_settings')){
	/**
	 * Twitter API Settings
	 * @return string
	 */
	function themify_manage_twitter_settings() {
		$data = themify_get_data();

		$prefix = 'setting-twitter_settings_';

		$consumer_key = themify_get( $prefix.'consumer_key' );
		$consumer_secret = themify_get( $prefix.'consumer_secret' );

		$output = '<p><label class="label" for="'.$prefix.'consumer_key'.'">'.__('Consumer Key', 'themify').'</label>';
		$output .= '<input type="text" id="'.$prefix.'consumer_key'.'" name="'.$prefix.'consumer_key'.'" class="width10" value="'.$consumer_key.'" /></p>';

		$output .= '<p><label class="label" for="'.$prefix.'consumer_secret'.'">'.__('Consumer Secret', 'themify').'</label>';
		$output .= '<input type="text" id="'.$prefix.'consumer_secret'.'" name="'.$prefix.'consumer_secret'.'" class="width10" value="'.$consumer_secret.'" /></p>';
		
		$output .= '<p><small>'.sprintf(
			__('<a href="%s" %s>Twitter access</a> is required for Themify Twitter widget and Twitter shortcode, read this <a href="%s" %s>documentation</a> for more details.', 'themify'),
			'https://dev.twitter.com/apps/new', 'target="_blank"',
			'http://themify.me/docs/setting-up-twitter', 'target="_blank"'
		)
		.'</small></p>';

		return $output;
	}
}

if(!function_exists('themify_webfonts_subsets')) {
	/**
	 * Module to specify additional characters subsets
	 * @param array Themify data
	 * @return string Module markup
	 * @since 1.3.9
	 */
	function themify_webfonts_subsets($data = array()){
		$data = themify_get_data();
		$key = 'setting-webfonts_subsets';
		$subsets = themify_get( $key );
		return '<p>
					<span class="label">' . __('Additional subsets', 'themify') . '</span> <input type="text" class="width10" name="'.$key.'" value="'.$subsets.'" /> <br />
					<span class="pushlabel">
					<a href="#" class="refresh-webfonts button">'.__('Refresh list', 'themify').'</a>
					<br/><small>'.__('Enter the additional character subsets you need to use from Google WebFonts separated by commas. Example: latin-ext,cyrillic').'</small></span>
				</p>';
	}
}

if ( ! function_exists( 'themify_entries_navigation' ) ) {
	/**
	 * Display module to select numbered pagination or links to previous and next posts.
	 * @param $data array
	 * @return $html Module markup.
	 * @since 1.6.0
	 */
	function themify_entries_navigation( $data = array() ) {
		$data = themify_get_data();
		$key = 'setting-entries_nav';
		$html = '<p>';
			// Numbered pagination
			$html .= '<label for="' . $key . '_numbered">';
			$html .= '<input ' . checked( isset( $data[$key] )? $data[$key] : 'numbered', 'numbered', false) . ' type="radio" id="' . $key . '_numbered" name="' . $key . '" value="numbered" /> ';
			$html .= __( 'Numbered Page Navigation (page 1, 2, 3, etc.)', 'themify' ) . '</label>';
			$html .= '<br/>';
			
			// Previous / Next links
			$html .= '<label for="' . $key . '_prevnext">';
			$html .= '<input ' . checked( isset( $data[$key] )? $data[$key] : '', 'prevnext', false ) . ' type="radio" id="' . $key . '_prevnext" name="' . $key . '" value="prevnext" /> ';
			$html .= __( 'Previous Posts and Next Posts Links', 'themify' ) . '</label>';
		$html .= '</p>';
		return $html;
	}
}

//////////////////////////////////////////////
// Add common modules
//////////////////////////////////////////////
if(!function_exists('themify_framework_theme_config_webfonts_subsets')){
	function themify_framework_theme_config_webfonts_subsets($themify_theme_config) {
		$themify_theme_config['panel']['settings']['tab']['general']['custom-module'][] =
			array(
				'title' => __('Google WebFonts Subsets', 'themify'),
				'function' => 'themify_webfonts_subsets'
			)
		;
		return $themify_theme_config;
	};
	add_filter('themify_theme_config_setup', 'themify_framework_theme_config_webfonts_subsets');
}

if( ! function_exists( 'themify_framework_theme_config_add_twitter_settings' ) ) {
	/**
	 * Twitter Settings Tab
	 * @param array $themify_theme_config
	 * @return array
	 */
	function themify_framework_theme_config_add_twitter_settings($themify_theme_config) {
		$themify_theme_config['panel']['settings']['tab']['twitter_settings'] = array(
			'title' => __('Twitter Settings', 'themify'),
			'id' => 'twitter_settings',
			'custom-module' => array(
				array(
					'title' => __('Twitter API Settings', 'themify'),
					'function' => 'themify_manage_twitter_settings'
				)
			)
		);
		return $themify_theme_config;
	};
	add_filter('themify_theme_config_setup', 'themify_framework_theme_config_add_twitter_settings');
}